#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>

void error_fatal (const char *message){
  perror (message);
  exit (1);
}

int main(){
  int flags;
  int fd;
  char buffer [] = "000006 mi09570 Jovan Jovic 3 \n";
  int file_size;

  if ( (fd = open ("studenti.txt", O_RDWR)) < 0)
    error_fatal ("open error");

  /* Pozicioniranje na odgovarajuce mesto u fajlu. */
  if ( (file_size = lseek (fd, 0, SEEK_END)) < 0)
    error_fatal ("lseek error");

  printf ("File size: %d\n", file_size);

  /* Dobijanje trenutno postavljenih flegova. */
  if ( (flags = fcntl (fd, F_GETFL, 0)) < 0)
    error_fatal ("fcntl get flags error");

  /* Postavljanje flega za pisanje. */
  flags = flags | O_APPEND;

  /* Postavljanje flega za dopisivanje. */
  if ( (flags = fcntl (fd, F_SETFL, flags)) < 0)
    error_fatal ("fcntl get flags error");

  /* Pozicioniranje na pocetak fajla. */
  if (lseek (fd, 0, SEEK_SET) < 0)
    error_fatal ("lseek error");

  /* Ispis novog korisnika. */
  if (write (fd, buffer, strlen (buffer)) != strlen (buffer))
    error_fatal ("write error");
  
  return 0;
}
