#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <assert.h>

void error_fatal (const char *message){
  perror (message);
  exit (1);
}

/* Program stampa statusne flegove za fajl odredjen deskriptorom ciji je broj zadat u komandnoj liniji.*/
int main(int argc, char **argv){
  int flags;
  int fd;

  /* Proverava se da li postoji tacno 2 argumenta komandne linije. */
  assert (argc == 2);

  /* Broj se pretvara iz stringa u ceo broj. */
  fd = atoi (argv[1]);

  /* Prikupljaju se flegovi. */
  if ( (flags = fcntl (fd, F_GETFL, 0)) < 0)
    error_fatal ("fcntl error");

  /* Odredjuje se rezim pristupa i ispisuje odgovarajuca poruka. */
  switch (flags & O_ACCMODE){
  case O_RDONLY:
    printf ("read only\n");
    break;
  case O_WRONLY:
    printf ("write only\n");
    break;
  case O_RDWR:
    printf ("read write\n");
    break;
  default:
    printf ("unknown access mode\n");
  }
  
  /* Odredjuju se vrednosti ostalih flegova i ako treba ispisuju poruke. */
  if (flags & O_APPEND)
    printf("append\n");
  if (flags & O_NONBLOCK)
    printf("non-blocking\n");

  return 0;
}
